Subject: RE: [PATCH] btrfs: Disable BTRFS on platforms having 256K pages

From: "Brian Cain" <[email-masked]>
Date: Sat, 12 Jun 2021 09:44:05 -0500

> -----Original Message-----
> From: Christophe Leroy <[email-masked]>
...
> Le 10/06/2021 à 15:54, Chris Mason a écrit :
> >
> >> On Jun 10, 2021, at 1:23 AM, Christophe Leroy
> <[email-masked]> wrote:
> >>
> >> With a config having PAGE_SIZE set to 256K, BTRFS build fails
> >> with the following message
> >>
> >> include/linux/compiler_types.h:326:38: error: call to
> '__compiletime_assert_791' declared with attribute error: BUILD_BUG_ON
> failed: (BTRFS_MAX_COMPRESSED % PAGE_SIZE) != 0
> >>
> >> BTRFS_MAX_COMPRESSED being 128K, BTRFS cannot support platforms
> with
> >> 256K pages at the time being.
> >>
> >> There are two platforms that can select 256K pages:
> >> - hexagon
> >> - powerpc
> >>
> >> Disable BTRFS when 256K page size is selected.
> >>
> >
> > We’ll have other subpage blocksize concerns with 256K pages, but this
> BTRFS_MAX_COMPRESSED #define is arbitrary.  It’s just trying to have an
> upper bound on the amount of memory we’ll need to uncompress a single
> page’s worth of random reads.
> >
> > We could change it to max(PAGE_SIZE, 128K) or just bump to 256K.
> >
> 
> But if 256K is problematic in other ways, is it worth bumping
> BTRFS_MAX_COMPRESSED to 256K ?
> 
> David, in below mail, said that 256K support would require deaper changes. So
> disabling BTRFS
> support seems the easiest solution for the time being, at least for Stable (I
> forgot the Fixes: tag
> and the CC: to stable).
> 
> On powerpc, 256k pages is a corner case, it requires customised binutils, so I
> don't think disabling
> BTRFS is a issue there. For hexagon I don't know.

Larger page sizes like this are typical for hexagon.  Disabling btrfs on hexagon seems appropriate.

-Brian